// EmpegUsbDevices.h: interface for the CEmpegUsbDevices class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EMPEGUSBDEVICES_H__99C65D60_0D82_11D3_9129_00104B62B7D4__INCLUDED_)
#define AFX_EMPEGUSBDEVICES_H__99C65D60_0D82_11D3_9129_00104B62B7D4__INCLUDED_

#pragma warning(disable : 4786)

#include <vector>
#include <string>

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// We have to be rather sneaky here since some of the symbols we're using
// aren't available on NT4.0 or Windows 95. We have to really dynamically
// link with the symbols.

class CEmpegUsbDevices  
{
    typedef std::vector<std::string> StringVector;
    StringVector m_devices;

    void FindDevices();
    void AppendDevice(std::string &str);

public:
    typedef StringVector::const_iterator const_iterator;

    CEmpegUsbDevices();
    virtual ~CEmpegUsbDevices();

    const_iterator begin() const
    {
	return m_devices.begin();
    }

    const_iterator end() const
    {
	return m_devices.end();
    }

    int GetCount() const
    {
	return m_devices.size();
    }

    std::string operator[](int i) const
    {
#ifdef ASSERT
	ASSERT(i >= 0);
	ASSERT(i < GetCount());
#endif
	return m_devices[i];
    }

    std::string GetDummy() const;
    static bool IsUsbSupported();
};

#endif // !defined(AFX_EMPEGUSBDEVICES_H__99C65D60_0D82_11D3_9129_00104B62B7D4__INCLUDED_)
